<!--|This file generated by command(leetcode description); DO NOT EDIT.    |-->
<!--+----------------------------------------------------------------------+-->
<!--|@author    openset <openset.wang@gmail.com>                           |-->
<!--|@link      https://github.com/openset                                 |-->
<!--|@home      https://github.com/openset/leetcode                        |-->
<!--+----------------------------------------------------------------------+-->

[< Previous](https://github.com/openset/leetcode/tree/master/problems/longest-increasing-subsequence "Longest Increasing Subsequence")
　　　　　　　　　　　　　　　　
[Next >](https://github.com/openset/leetcode/tree/master/problems/smallest-rectangle-enclosing-black-pixels "Smallest Rectangle Enclosing Black Pixels")

## [301. Remove Invalid Parentheses (Hard)](https://leetcode.com/problems/remove-invalid-parentheses "删除无效的括号")

<p>Remove the minimum number of invalid parentheses in order to make the input string valid. Return all possible results.</p>

<p><strong>Note:</strong>&nbsp;The input string may contain letters other than the parentheses <code>(</code> and <code>)</code>.</p>

<p><b>Example 1:</b></p>

<pre>
<b>Input:</b> &quot;()())()&quot;
<b>Output:</b> [&quot;()()()&quot;, &quot;(())()&quot;]
</pre>

<p><b>Example 2:</b></p>

<pre>
<b>Input:</b> &quot;(a)())()&quot;
<b>Output:</b> [&quot;(a)()()&quot;, &quot;(a())()&quot;]
</pre>

<p><b>Example 3:</b></p>

<pre>
<b>Input:</b> &quot;)(&quot;
<b>Output: </b>[&quot;&quot;]
</pre>

### Related Topics
  [[Depth-first Search](https://github.com/openset/leetcode/tree/master/tag/depth-first-search/README.md)]
  [[Breadth-first Search](https://github.com/openset/leetcode/tree/master/tag/breadth-first-search/README.md)]

### Similar Questions
  1. [Valid Parentheses](https://github.com/openset/leetcode/tree/master/problems/valid-parentheses) (Easy)

### Hints
<details>
<summary>Hint 1</summary>
Since we don't know which of the brackets can possibly be removed, we try out all the options!
</details>

<details>
<summary>Hint 2</summary>
We can use recursion to try out all possibilities for the given expression. For each of the brackets, we have 2 options:

<ol>
<li> We keep the bracket and add it to the expression that we are building on the fly during recursion.</li>
<li> OR, we can discard the bracket and move on.
</ol>
</details>

<details>
<summary>Hint 3</summary>
The one thing all these valid expressions have in common is that they will all be of the same length i.e. as compared to the original expression, all of these expressions will have the same number of characters removed. 

Can we somehow find the number of misplaced parentheses and use it in our solution?
</details>

<details>
<summary>Hint 4</summary>
The one thing all these valid expressions have in common is that they will all be of the same length i.e. as compared to the original expression, all of these expressions will have the same number of characters removed. 

Can we somehow find the number of misplaced parentheses and use it in our solution?
</details>

<details>
<summary>Hint 5</summary>
For every left parenthesis, we should have a corresponding right parenthesis. We can make use of two counters which keep track of misplaced left and right parenthesis and in one iteration we can find out these two values. 

<pre>
0 1 2 3 4 5 6 7
( ) ) ) ( ( ( )  
i = 0, left = 1, right = 0
i = 1, left = 0, right = 0
i = 2, left = 0, right = 1
i = 3, left = 0, right = 2
i = 4, left = 1, right = 2
i = 5, left = 2, right = 2
i = 6, left = 3, right = 2
i = 7, left = 2, right = 2
</pre>

We have 2 misplaced left and 2 misplaced right parentheses.
</details>

<details>
<summary>Hint 6</summary>
We found out that the exact number of left and right parenthesis that has to be removed to get a valid expression. So, e.g. in a 1000 parentheses string, if there are 2 misplaced left and 2 misplaced right parentheses, after we are done discarding 2 left and 2 right parentheses, we will have only one option per remaining character in the expression i.e. to consider them. We can't discard them.
</details>
